#ifndef HC_BLE_H
#define HC_BLE_H

#include <errno.h>
#include <soc.h>
#include <stddef.h>
#include <string.h>
#include <zephyr/kernel.h>
#include <zephyr/sys/byteorder.h>
#include <zephyr/sys/printk.h>
#include <zephyr/types.h>

#include <zephyr/bluetooth/addr.h>
#include <zephyr/bluetooth/bluetooth.h>
#include <zephyr/bluetooth/conn.h>
#include <zephyr/bluetooth/hci.h>
#include <zephyr/bluetooth/uuid.h>

#include <zephyr/bluetooth/gatt.h>

#define HC_BLE_THREAD_STACK_SIZE 500
#define HC_BLE_THREAD_PRIORITY 1

static K_SEM_DEFINE(ble_init_ok, 0, 1);

extern k_tid_t core_thread;

extern bool hc_save_status_request;

/**
 * @brief Initialize BLE peripheral and setup services
 * @return 0 when successful, negative error value otehrwise
 */
int hc_bt_init();

/**
 * @brief Start BLE advertisement
 * @return 0 on success, negative error value otehrwise
 */
int hc_bt_start();

/**
 * @brief Stop BLE advertisement
 * @return 0 on success, negative error value otehrwise
 */
int hc_bt_stop();

/**
 * @brief Change BLE name
 * @param new_name Pointer to array containing new name
 * @param new_name_lenght Lenght of new name
 */
void hc_bt_change_name(uint8_t *new_name, uint8_t new_name_lenght);

#endif